// client.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"
#include <winsock2.h>
#include <math.h>
#include "messages.h"

#define MAX_LOADSTRING 100
#define Say(_str) MessageBox(hWnd,_str,"Message",0);

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];								// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];								// The title bar text


HWND hWnd;
HWND hEdit1,hButton1;

int PORT=2345;
SOCKET socket1;
sockaddr_in addr1,addr2;
WSADATA data1;
struct hostent FAR *info;
TCHAR szLocalName[128];
TCHAR szServerIP[16];

const int ID_EDIT1=1324;
const int ID_BUTTON1=1235;
const int MAX_DATA=1000;

HANDLE hThread2;
DWORD dwThread2ID;


// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
void                InitSocket();
void                GetTask(sockaddr_in server);
void                CompleteTask(sockaddr_in server,int From,int To);
int                 IsPrime(int Number);
DWORD WINAPI        SecondThreadFunction(PVOID pvParam);

void InitSocket()
{
	WSAStartup(0x202,&data1);
	ZeroMemory(szLocalName,sizeof(szLocalName));
	addr1.sin_family=AF_INET;
	addr1.sin_addr.s_addr=INADDR_ANY;
	addr1.sin_port=htons(PORT);
	addr2=addr1;

	socket1=socket(AF_INET,SOCK_DGRAM,0);
	if(socket1==-1) Say("socket failed");
}

void GetTask(sockaddr_in server)
{
	int Data[MAX_DATA];
	Data[0]=CM_NEW;
	sendto(socket1,(char*)Data,MAX_DATA,0,(const sockaddr*)&server,sizeof(server));

	int size=sizeof(addr2);
	do
		recvfrom(socket1,(char*)Data,MAX_DATA,0,(struct sockaddr*)&addr2,&size);
	while(addr2.sin_addr.S_un.S_addr!=server.sin_addr.S_un.S_addr);
	if(Data[0]==CM_COMPLETED)
	{
		Say("Calculations complited");
		PostQuitMessage(0);
	}
	if(Data[0]==CM_TASK)
	{
		CompleteTask(server,Data[1],Data[2]);
	}
}

void CompleteTask(sockaddr_in server,int From,int To)
{
	int Data[MAX_DATA];
	Data[0]=CM_COMPLETED;
	Data[1]=0;
	Data[2]=From;
	Data[3]=To;

	for(int i=From;i<=To;i++)
		if(IsPrime(i)==1)
		{
			Data[Data[0]+4]=i;
			Data[0]++;
		}


	sendto(socket1,(char*)Data,MAX_DATA,0,(struct sockaddr*)&server,sizeof(addr2));
	Data[0]=CM_NEW;
	char buffer[10];
	wsprintf(buffer,"%d",To);
	Say(buffer);
}

int IsPrime(int Number)
{
	for(int i=0;i<=sqrt(Number)/6;i++)
		if((Number%(i*6+1)==0)||(Number%(i*6+5)==0)) return 0;
	return 1;
}

DWORD WINAPI SecondThreadFunction(PVOID pvParam)
{
	while(1)
		GetTask(addr2);
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	TCHAR szHello[MAX_LOADSTRING];
	LoadString(hInst, IDS_HELLO, szHello, MAX_LOADSTRING);

	switch (message) 
	{
		case WM_CREATE:
			InitSocket();
			break;


		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{
				case ID_BUTTON1:
					GetDlgItemText(hWnd,ID_EDIT1,szServerIP,16);
					addr2.sin_addr.S_un.S_addr=inet_addr(szServerIP);
					hThread2=CreateThread(NULL,0,SecondThreadFunction,NULL,0,&dwThread2ID);
					break;

				case IDM_ABOUT:
				   DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				   break;
				case IDM_EXIT:
				   DestroyWindow(hWnd);
				   break;
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;

		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}


int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_CLIENT, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_CLIENT);

	hEdit1=CreateWindow("EDIT",NULL,WS_VISIBLE|WS_CHILD,100,100,100,20,
		hWnd,(HMENU)ID_EDIT1,GetModuleHandle(NULL),NULL);

	hButton1=CreateWindow("BUTTON","Send",WS_VISIBLE|WS_CHILD,100,150,100,20,
		hWnd,(HMENU)ID_BUTTON1,GetModuleHandle(NULL),NULL);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_CLIENT);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW);
	wcex.lpszMenuName	= (LPCSTR)IDC_CLIENT;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);
   MoveWindow(hWnd,400,400,300,300,TRUE);

   return TRUE;
}


// Mesage handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
				return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}
